diff --git a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
index fe99dacb7..1cbab820d 100644
--- a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
+++ b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
@@ -8,7 +8,8 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.packet.PacketBlockEvent;
-import net.minecraft.core.net.packet.PacketChat;
+import net.minecraft.core.net.packet.PacketMessage;
+import net.minecraft.core.net.packet.PacketMessageTranslatable;
 import net.minecraft.core.net.packet.PacketCustomPayload;
 import net.minecraft.core.net.packet.PacketEntityEvent;
 import net.minecraft.core.net.packet.PacketEntityTagData;
@@ -124,67 +125,85 @@ public class WorldServer extends World {
 
     @Override
     protected void updateSleepingPlayers() {
-        if(areEnoughPlayersFullyAsleep())
-        {
-            boolean wasInterrupted = false;
-            if(getSpawnerConfig().canHostileSpawn(this) && getPlayersRequiredToSkipNight() <= 1)
-            {
-                wasInterrupted = SpawnerMobs.performSleepSpawning(this, players);
-            }
-            if(!wasInterrupted)
-            {
-                if(MinecraftServer.getInstance() != null && players.size() > 1) {
-                    if(getPlayersRequiredToSkipNight() <= 1) {
-                        Player player = null;
-                        for(Player player2 : players) {
-                            if(player2.isPlayerFullyAsleep()) {
-                                player = player2;
-                            }
-                        }
-                        if(player != null) {
-                            MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new PacketChat(TextFormatting.YELLOW + player.getDisplayName() + TextFormatting.ORANGE + " went to sleep. Sweet dreams!"), dimension.id);
-                        }
-                    }
-                }
-
-                long timePlusOneDay = getLevelData().getWorldTime() + Global.DAY_LENGTH_TICKS;
-                getLevelData().setWorldTime(timePlusOneDay - timePlusOneDay % Global.DAY_LENGTH_TICKS + getWorldType().getSunriseTick(this) + Global.DAY_LENGTH_TICKS / 24);
-                wakeUpAllPlayers();
+        if (!this.areEnoughPlayersFullyAsleep()) return;
+
+        final boolean wasInterrupted =
+            getSpawnerConfig().canHostileSpawn(this) &&
+            getPlayersRequiredToSkipNight() <= 1 &&
+            SpawnerMobs.performSleepSpawning(this, players);
+        if (wasInterrupted) return;
+
+        send_message: {
+            if (MinecraftServer.getInstance() == null) break send_message;
+            if (players.size() <= 1) break send_message;
+            if (this.getPlayersRequiredToSkipNight() <= 1) break send_message;
+
+            Player sleeper = null;
+            for (final var p : players) {
+                if (!p.isPlayerFullyAsleep()) continue;
+                sleeper = p;
+                break;
             }
+            if (sleeper == null) break send_message;
+
+            MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(
+                new PacketMessageTranslatable(
+                    TextFormatting.Base.ORANGE,
+                    "messages.sleep.succeed",
+                    TextFormatting.scoped(sleeper.getDisplayName())),
+                dimension.id
+            );
         }
+
+        long timePlusOneDay = getLevelData().getWorldTime() + Global.DAY_LENGTH_TICKS;
+        getLevelData().setWorldTime(timePlusOneDay - timePlusOneDay % Global.DAY_LENGTH_TICKS + getWorldType().getSunriseTick(this) + Global.DAY_LENGTH_TICKS / 24);
+        wakeUpAllPlayers();
     }
 
     @Override
-    public void updateEnoughPlayersSleepingFlag(Player player)
-    {
-        enoughPlayersSleeping = false;
-        if(players.size() > 0) {
-            int playersSleeping = 0;
-            int req = getPlayersRequiredToSkipNight();
-            for(Player p : players)
-                if(p.isPlayerSleeping()) playersSleeping++;
-            if(playersSleeping >= req) {
-                enoughPlayersSleeping = true;
-            }
+    public void updateEnoughPlayersSleepingFlag(Player player) {
+        if (players.size() <= 0) return;
+        this.enoughPlayersSleeping = false;
 
-            if(MinecraftServer.getInstance() != null && player != null && players.size() > 1 && req > 1) {
-                int moreReq = req - playersSleeping;
-                if(player.isPlayerSleeping()) {
-                    MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new PacketChat(TextFormatting.YELLOW + player.username + TextFormatting.ORANGE + " went to bed."), dimension.id);
-                }else {
-                    MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new PacketChat(TextFormatting.YELLOW + player.username + TextFormatting.ORANGE + " has left their bed."), dimension.id);
-                }
-                if(moreReq > 0) {
-                    if(moreReq > 1) {
-                        MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new PacketChat(TextFormatting.LIGHT_GRAY + "" + moreReq + " more players are required to sleep to skip to daytime"), dimension.id);
-                    }else {
-                        MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new PacketChat(TextFormatting.LIGHT_GRAY + "1 more player is required to sleep to skip to daytime"), dimension.id);
-                    }
-
-                }
+        final int required = getPlayersRequiredToSkipNight();
+        int playersSleeping = 0;
+        for (final var p : players) {
+            if (!p.isPlayerSleeping()) break;
+            if (playersSleeping >= required) {
+                this.enoughPlayersSleeping = true;
+                break;
             }
+            playersSleeping++;
         }
 
+        if (player == null) return;
+        if (MinecraftServer.getInstance() == null) return;
+        if (players.size() <= 1) return;
+        if (required <= 1) return;
+
+        MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(
+            new PacketMessageTranslatable(
+                TextFormatting.Base.ORANGE,
+                (player.isPlayerSleeping()) 
+                    ? "messages.sleep.enter_bed" 
+                    : "messages.sleep.exit_bed",
+                TextFormatting.scoped(player.getDisplayName())),
+            dimension.id
+        );
+
+        if (this.enoughPlayersSleeping) return;
+        final int moreReq = required - playersSleeping;
+        assert moreReq > 0;
+
+        MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(
+            new PacketMessageTranslatable(
+                TextFormatting.Base.LIGHT_GRAY,
+                (moreReq != 1)
+                    ? "messages.sleep.more_required"
+                    : "messages.sleep.more_required.singular",
+                Integer.toString(moreReq)),
+            dimension.id
+        );
     }
 
     public @NotNull Entity getEntityFromId(int i)
@@ -268,7 +287,7 @@ public class WorldServer extends World {
 
     @Override
     public void sendGlobalMessage(String message){
-        mcServer.playerList.sendPacketToAllPlayers(new PacketChat(message));
+        mcServer.playerList.sendPacketToAllPlayers(new PacketMessage(message));
     }
     @Override
     public void addRainbow(int rainbowTicks){
